//+------------------------------------------------------------------+
//|                                        MTF tick newBar newZZ.mq4 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern int  MagicNumber    =  1000000;
int         TimeFrame[8]   = {PERIOD_M1, 
                              PERIOD_M5, 
                              PERIOD_M15, 
                              PERIOD_M30,
                              PERIOD_H1,
                              PERIOD_H4,
                              PERIOD_D1, 
                              PERIOD_W1};
int         tf;
datetime    CurrTime1,
            CurrTime5,
            CurrTime15,
            CurrTime30,
            CurrTime60,
            CurrTime240,
            CurrTime1440,
            CurrTime10080;
datetime    PrevTime1,
            PrevTime5,
            PrevTime15,
            PrevTime30,
            PrevTime60,
            PrevTime240,
            PrevTime1440,
            PrevTime10080;
datetime    Curr_zz1,
            Curr_zz5,
            Curr_zz15,
            Curr_zz30,
            Curr_zz60,
            Curr_zz240,
            Curr_zz1440,
            Curr_zz10080;
datetime    Prev_zz1,
            Prev_zz5,
            Prev_zz15,
            Prev_zz30,
            Prev_zz60,
            Prev_zz240,
            Prev_zz1440,
            Prev_zz10080;
//ind ZZ duomenys
int         dp =  12;
int         dv =  5;            
int         bs =  3;         

//-----------------------------------------------------------------------------
//Procentas, kuriuo ilgasis spindulys turi buti ilgesnis uz sekanti trumpaji
//-----------------------------------------------------------------------------
extern double    RayDiffPercent     = 61.8;      
//********************************************************************************
//| expert initialization function                                   |
//********************************************************************************
int init()
  {
//----
   
//----
   return(0);
  }
//******************************************************************************
//| expert deinitialization function                                 |
//******************************************************************************
int deinit()
  {
//----
   
//----
   return(0);
  }
//****************************************************************************
//| expert start function                                            |
//****************************************************************************
//****************************************************************************
//| expert start function                                            |
//****************************************************************************
int start()
{
	//----
	int    i, ii, iii;
	int k; 
	int ke;
  
	for(tf=0; tf<7; tf++)
    {
		if(tf == 0)
        {
            int mn1 = MagicNumber + TimeFrame[tf];

            //---------------------------
            //NewTick
            //---------------------------
            


            //---------------------------
            //NewBar M1
            //---------------------------

            CurrTime1 = iTime(NULL,TimeFrame[tf],1);
            if (CurrTime1!=PrevTime1)
            {
              Print("newTime",mn1, "   ",TimeToStr(CurrTime1));
				  PrevTime1 = CurrTime1;
            }																	// end if (CurrTime1!=PrevTime1)
            
            //---------------------------
            //NewZigZag  M1
            //---------------------------

			   double zz1;
            k=iBars(NULL, TimeFrame[tf]); 	                                       	 //esamu baru skaicius ekrane
            ke=0;				                                                       	    //rastu ekstremumu skaicius
            for (i=1; i<k; i++) 
            {
            	 zz1=iCustom(NULL, TimeFrame[tf], "ZigZag", dp, dv, bs, 0, i);
                if (zz1!=0) 
                {                	
                	ke++;
                  if (ke==2)			                                          	     //jei rasti du ekstremumai 
                  {
                     Curr_zz1 = zz1;
                     break;
                  }
                }															           //end (zz1!=0)
            } 
            																	              //end for(i=1; i<k; i++) 
            if(Curr_zz1!=Prev_zz1)
			   {
				   Print("newZZ_1=",Curr_zz1);
			      Prev_zz1=Curr_zz1;
           
			   } 																		//end if(Curr_zz1!=Prev_zz1)																			
		 }																			//end if(tf == 0)
		if(tf == 1)
		{
            int mn5 = MagicNumber + TimeFrame[tf];

            //---------------------------
            //NewTick
            //---------------------------
            

            //---------------------------
            //NewBar M5
            //---------------------------

            CurrTime5 = iTime(NULL,TimeFrame[tf],1);
            if (CurrTime5!=PrevTime5)
            {
               Print("newTime",mn5, "   ",TimeToStr(CurrTime5));
				  PrevTime5 = CurrTime5;
            }																		//end if (CurrTime5!=PrevTime5)
            
            //---------------------------
            //NewZigZag M5
            //---------------------------

            double zz5;
            k=iBars(NULL, TimeFrame[tf]); 	                                       	 //esamu baru skaicius ekrane
            ke=0;				                                                       	    //rastu ekstremumu skaicius
            for (i=1; i<k; i++) 
            {
            	zz5=iCustom(NULL, TimeFrame[tf], "ZigZag", dp, dv, bs, 0, i);
                if (zz5!=0) 
                {
                 	ke++;
                  if (ke==2)			                                          	     //jei rasti du ekstremumai 
                  {
                     Curr_zz5 = zz5;
                     break;
                  }
                }														           //end (zz1!=0)
            } 
            																	              //end for(i=1; i<k; i++) 
           if(Curr_zz5!=Prev_zz5)
			   {
				  Print("newZZ_5=",Curr_zz5);
				  Prev_zz5=Curr_zz5;
           
			   } 																		//end if(Curr_zz1!=Prev_zz1)																			
		}						
		if(tf == 2)
		{
            int mn15 = MagicNumber + TimeFrame[tf];
            //---------------------------
            //NewTick
            //---------------------------
            
            //---------------------------
            //NewBar M15
            //---------------------------
            CurrTime15 = iTime(NULL,TimeFrame[tf],1);
            if (CurrTime15!=PrevTime15)
            {
            	Print("newTime",mn15, "   ",TimeToStr(CurrTime15));
				


				PrevTime15 = CurrTime15;
            }
            
            //---------------------------
            //NewZigZag M15
            //---------------------------
            
            double zz15;
            k=iBars(NULL, TimeFrame[tf]); 	                                       	 //esamu baru skaicius ekrane
            ke=0;				                                                       	    //rastu ekstremumu skaicius
            for (i=1; i<k; i++) 
            {
            	zz15=iCustom(NULL, TimeFrame[tf], "ZigZag", dp, dv, bs, 0, i);
                if (zz15!=0) 
                {
                	
                	ke++;
                  if (ke==2)			                                          	     //jei rasti du ekstremumai 
                  {
                     Curr_zz15 = zz15;
                     break;
                  }
                }
               																           //end (zz1!=0)
            } 
            																	              //end for(i=1; i<k; i++) 
           if(Curr_zz15!=Prev_zz15)
			{
				Print("newZZ_15=",Curr_zz15);
				Prev_zz15=Curr_zz15;
           
			} 																		//end if(Curr_zz1!=Prev_zz1)																			
		}			

		if(tf == 3)
		{
            int mn30 = MagicNumber + TimeFrame[tf];
            //---------------------------
            //NewTick
            //---------------------------
            
            //---------------------------
            //NewBar M30
            //---------------------------
            CurrTime30 = iTime(NULL,TimeFrame[tf],1);
            if (CurrTime30!=PrevTime30)
            {
            	Print("newTime",mn30, "   ",TimeToStr(CurrTime30));
				


				PrevTime30 = CurrTime30;
            }
            
            //---------------------------
            //NewZigZag M30
            //---------------------------
            double zz30;
            k=iBars(NULL, TimeFrame[tf]); 	                                       	 //esamu baru skaicius ekrane
            ke=0;				                                                       	    //rastu ekstremumu skaicius
            for (i=1; i<k; i++) 
            {
            	zz30=iCustom(NULL, TimeFrame[tf], "ZigZag", dp, dv, bs, 0, i);
                if (zz30!=0) 
                {
                	
                	ke++;
                  if (ke==2)			                                          	     //jei rasti du ekstremumai 
                    {
                     Curr_zz30 = zz30;
                     break;
                  }
                }														           //end (zz1!=0)
            } 
            																	              //end for(i=1; i<k; i++) 
           if(Curr_zz30!=Prev_zz30)
			{
				Print("newZZ_30=",Curr_zz30);
				Prev_zz30=Curr_zz30;
           
			} 																		//end if(Curr_zz1!=Prev_zz1)																			
		}			

		if(tf == 4)
		{
            int mn60 = MagicNumber + TimeFrame[tf];
            //---------------------------
            //NewTick
            //---------------------------
            
            //---------------------------
            //NewBar H1
            //---------------------------
            CurrTime60= iTime(NULL,TimeFrame[tf],1);
            if (CurrTime60!=PrevTime60)
            {
            	Print("newTime",mn60, "   ",TimeToStr(CurrTime60));
				


				PrevTime60 = CurrTime60;
            }
            
            //---------------------------
            //NewZigZag H1
            //---------------------------
            double zz60;
            k=iBars(NULL, TimeFrame[tf]); 	                                       	 //esamu baru skaicius ekrane
            ke=0;				                                                       	    //rastu ekstremumu skaicius
            for (i=1; i<k; i++) 
            {
            	zz60=iCustom(NULL, TimeFrame[tf], "ZigZag", dp, dv, bs, 0, i);
                if (zz60!=0) 
                {
                	
                	ke++;
                  if (ke==2)			                                          	     //jei rasti du ekstremumai 
                  {
                     Curr_zz60 = zz60;
                     break;
                  }
                }																           //end (zz1!=0)
            } 
            																	              //end for(i=1; i<k; i++) 
           if(Curr_zz60!=Prev_zz60)
			{
				Print("newZZ_60=",Curr_zz60);
				Prev_zz60=Curr_zz60;
           
			} 																		//end if(Curr_zz1!=Prev_zz1)																			
		}			

		if(tf == 5)
		{
            int mn240 = MagicNumber + TimeFrame[tf];
            //---------------------------
            //NewTick
            //---------------------------
            
            //---------------------------
            //NewBar H4
            //---------------------------
            CurrTime240 = iTime(NULL,TimeFrame[tf],1);
            if (CurrTime240!=PrevTime240)
            {
            	Print("newTime",mn240, "   ",TimeToStr(CurrTime240));
				


				PrevTime240 = CurrTime240;
            }
            
            //---------------------------
            //NewZigZag H4
            //---------------------------
            double zz240;
            k=iBars(NULL, TimeFrame[tf]); 	                                       	 //esamu baru skaicius ekrane
            ke=0;				                                                       	    //rastu ekstremumu skaicius
            for (i=1; i<k; i++) 
            {
            	zz240=iCustom(NULL, TimeFrame[tf], "ZigZag", dp, dv, bs, 0, i);
                if (zz240!=0) 
                {
                	
                	ke++;
                  if (ke==2)			                                          	     //jei rasti du ekstremumai 
                  {
                     Curr_zz240 = zz240;
                     break;
                  }
                }																           //end (zz1!=0)
            } 
            																	              //end for(i=1; i<k; i++) 
           if(Curr_zz240!=Prev_zz240)
			{
				Print("newZZ_240=",Curr_zz240);
				Prev_zz240=Curr_zz240;
           
			} 																		//end if(Curr_zz1!=Prev_zz1)																			
		}			

		if(tf == 6)
		{
            int mn1440 = MagicNumber + TimeFrame[tf];
            //---------------------------
            //NewTick
            //---------------------------
            
            //---------------------------
            //NewBar D1
            //---------------------------
            CurrTime1440 = iTime(NULL,TimeFrame[tf],1);
            if (CurrTime1440!=PrevTime1440)
            {
            	Print("newTime",mn1440, "   ",TimeToStr(CurrTime1440));
				


				PrevTime1440 = CurrTime1440;
            }
            
            //---------------------------
            //NewZigZag D1
            //---------------------------
            double zz1440;
            k=iBars(NULL, TimeFrame[tf]); 	                                       	 //esamu baru skaicius ekrane
            ke=0;				                                                       	    //rastu ekstremumu skaicius
            for (i=1; i<k; i++) 
            {
            	zz1440=iCustom(NULL, TimeFrame[tf], "ZigZag", dp, dv, bs, 0, i);
                if (zz1440!=0) 
                {
                	
                	ke++;
                  if (ke==2)			                                          	     //jei rasti du ekstremumai 
                     {
                     Curr_zz1440 = zz1440;
                     break;
                  }
                }																           //end (zz1!=0)
            } 
            																	              //end for(i=1; i<k; i++) 
           if(Curr_zz1440!=Prev_zz1440)
			{
				Print("newZZ_1440=",Curr_zz1440);
				Prev_zz1440=Curr_zz1440;
           
			} 																		//end if(Curr_zz1!=Prev_zz1)																			
		}			
		if(tf == 7)
		{
            int mn10080 = MagicNumber + TimeFrame[tf];
            //---------------------------
            //NewTick
            //---------------------------
            
            //---------------------------
            //NewBar W1
            //---------------------------
             CurrTime10080 = iTime(NULL,TimeFrame[tf],1);
            if (CurrTime10080!=PrevTime10080)
            {
            	Print("newTime",mn10080, "   ",TimeToStr(CurrTime10080));
				


				PrevTime10080 = CurrTime10080;
            }
            //---------------------------
            //NewZigZag W1
            //---------------------------
              double zz10080;
            k=iBars(NULL, TimeFrame[tf]); 	                                       	 //esamu baru skaicius ekrane
            ke=0;				                                                       	    //rastu ekstremumu skaicius
            for (i=1; i<k; i++) 
            {
            	zz10080=iCustom(NULL, TimeFrame[tf], "ZigZag", dp, dv, bs, 0, i);
                if (zz10080!=0) 
                {
                	
                	ke++;
                  if (ke==2)			                                          	     //jei rasti du ekstremumai 
                  {
                     Curr_zz10080 = zz10080;
                     break;
                  }
                }																           //end (zz1!=0)
            } 
            																	              //end for(i=1; i<k; i++) 
           if(Curr_zz10080!=Prev_zz10080)
			{
				Print("newZZ_10080=",Curr_zz10080);
				Prev_zz10080=Curr_zz10080;
			} 																	// end if(Curr_zz10080!=Prev_zz10080)
     

		}
    }																			 //end for(tf=1; tf<7; tf++)
  
//----
   return(0);
  }																								// end start
//+------------------------------------------------------------------+
//Funkcijos
//--------------------------------------------------------------------
double EquationDirect(double x1, double y1, double x2, double y2, double x) 
{
  	if (x2==x1) 		return(y1);
  	return(((x-x1)*(y2-y1)/(x2-x1))+y1);
}
//********************************************************************	
datetime GetExtremumZZ_2TF_Bars(string sy="", int tf1=0, int tf2=0, int ne=0, int dp=12, int dv=5, int bs=3) 
{
  if (sy=="" || sy=="0") sy=Symbol();
  double zz1,  zz2, p1, p2;
  int    i, k1=iBars(sy, tf1), ke=0;
  int    j;
  datetime t;
  
  for (i=1; i<k1; i++) 
  {
    zz1=iCustom(sy, tf1, "ZigZag", dp, dv, bs, 0, i);
    if (zz1!=0) 
    {
      ke++;
      if (ke>ne) 
         {p1=zz1;datetime t1=iTime(sy,tf1,i);}
    }
    
  }
  Print("                                  p1   " ,p1);
  Print("                                  t1   ", TimeToStr(t1,  TIME_DATE|TIME_MINUTES));
  for (j=1; j<Bars; j++) 
  {
    zz2=iCustom(sy, tf2, "ZigZag", dp, dv, bs, 0, j);
    if (zz2!=0) 
    {
      p2=zz2;
      Print("p2=   ",p2);
      t=iTime(sy, tf2, j);
      if(p1==p2)
      {
         Print("skaiciavimo pradzia nuo   ",TimeToStr(t, TIME_DATE|TIME_MINUTES));
         return(t);
      }
    }
  }
  return(0);
}
//------------------------------------------





